package body beep is

   procedure Beep
     (This : IBeep_Type)
   is
   begin
      AdaCom.Errors.Check_HR(
         Pointer(This).lpvtbl.Beep(Pointer(This)
         ));
   end Beep;

   procedure Initialize (This : in out IBeep_Type) is
   begin
      Set_IID(This, IID_IBeep);
   end Initialize;

   function Pointer (This : in IBeep_Type)
     return Pointer_To_IBeep
   is
   begin
      return To_IBeep(Address(This));
   end Pointer;

   procedure Display
     (This : IMessage_Type;
      message : AdaWin.BSTR)
   is
   begin
      AdaCom.Errors.Check_HR(
         Pointer(This).lpvtbl.Display(Pointer(This),
            message
         ));
   end Display;

   procedure Initialize (This : in out IMessage_Type) is
   begin
      Set_IID(This, IID_IMessage);
   end Initialize;

   function Pointer (This : in IMessage_Type)
     return Pointer_To_IMessage
   is
   begin
      return To_IMessage(Address(This));
   end Pointer;

   procedure Beeps
     (This : IStat_Type;
      calls : Pointer_To_Interfaces_C_int)
   is
   begin
      AdaCom.Errors.Check_HR(
         Pointer(This).lpvtbl.Beeps(Pointer(This),
            calls
         ));
   end Beeps;

   procedure Initialize (This : in out IStat_Type) is
   begin
      Set_IID(This, IID_IStat);
   end Initialize;

   function Pointer (This : in IStat_Type)
     return Pointer_To_IStat
   is
   begin
      return To_IStat(Address(This));
   end Pointer;

end beep;
